ScriptName EggFactorymasterTimer Extends Quest

;-- Variables ---------------------------------------
Bool eventick = True

;-- Properties --------------------------------------
Spell[] Property AspectAbilites Auto
Faction[] Property AspectFactions Auto
wicourierscript Property CourierScript Auto
Int[] Property DragonSoulCount Auto
Int[] Property EggCountsLeft Auto
Int[] Property EggCountsMax Auto
Int[] Property EggCountsMin Auto
GlobalVariable Property EggFactoryBellyMult Auto
GlobalVariable Property EggFactoryBleedout Auto
Faction Property EggFactoryCounter Auto
Book Property EggFactoryCourierNote Auto
GlobalVariable Property EggFactoryDismount Auto
GlobalVariable Property EggFactoryFirstPerson Auto
Sound Property EggFactoryLaborFemale Auto
Sound Property EggFactoryLaborMale Auto
GlobalVariable Property EggFactoryMaxMultiples Auto
GlobalVariable Property EggFactoryMaxScale Auto
GlobalVariable Property EggFactoryMinMultiples Auto
GlobalVariable Property EggFactoryPlayerMilkCooldown Auto
GlobalVariable Property EggFactoryPlayerMilkState Auto
GlobalVariable Property EggFactoryScaleMethod Auto
GlobalVariable Property EggFactoryShuffleMode Auto
GlobalVariable Property EggFactoryShutdown Auto
GlobalVariable Property EggFactoryVoiceVolume Auto
GlobalVariable Property EggFactorymultiLimit Auto
MiscObject[] Property EggItems Auto
Ingredient[] Property EggItemsReal Auto
GlobalVariable[] Property ExtraChanceVars Auto
GlobalVariable[] Property LaborRateVars Auto
Int[] Property LaborRates Auto
Int[] Property LaborStates Auto
Keyword Property LocTypePlayerHouse Auto
Quest Property MQ104 Auto
Faction Property PlayerFaction Auto
GlobalVariable[] Property PregSpeedVars Auto
Int[] Property PregTypes Auto
Int[] Property PushesToLay Auto
GlobalVariable[] Property ShuffleVars Auto
GlobalVariable[] Property SkipEarlyVars Auto
Int[] Property TicsToNextPush Auto
GlobalVariable[] Property TwinChanceVars Auto
Bool[] Property UncurseQueued Auto
ReferenceAlias[] Property Victims Auto
GlobalVariable[] Property WaterGrowthVars Auto
Float[] Property bellyscalemults Auto
Bool[] Property doingsecondload Auto
Bool Property eggfactory340check Auto
Bool Property eggfactory360check Auto
Bool Property eggfactory380check Auto
MiscObject Property eggfactorycharm Auto
Keyword Property eggfactoryenchfertile Auto
Keyword Property eggfactoryenchhold Auto
Armor Property eggfactoryfluid Auto
Spell Property eggfactorylabordebuff Auto
Potion Property eggfactoryuncurse Auto
Potion Property foodeggpotion Auto
Int[] Property gestation_cur Auto
Int[] Property gestation_total Auto
Float[] Property lastgrowth Auto
Keyword Property loctypecity Auto
Keyword Property loctypeinn Auto
Keyword Property loctypetown Auto
Bool Property notesent Auto
Int[] Property rapidpoints Auto
Int[] Property twinscount Auto
Bool[] Property wassneaking Auto

;-- Functions ---------------------------------------

; Skipped compiler generated GetState

; Skipped compiler generated GotoState

Bool Function IsChildRace(Race ThisRace)
  String RaceName = ThisRace.GetName() ; #DEBUG_LINE_NO:113
  Bool IsChild = False ; #DEBUG_LINE_NO:114
  If stringutil.Find(RaceName, "Child", 0) != -1 ; #DEBUG_LINE_NO:116
    IsChild = True ; #DEBUG_LINE_NO:117
  ElseIf stringutil.Find(RaceName, "Little", 0) != -1 ; #DEBUG_LINE_NO:118
    IsChild = True ; #DEBUG_LINE_NO:119
  ElseIf stringutil.Find(RaceName, "117", 0) != -1 ; #DEBUG_LINE_NO:120
    IsChild = True ; #DEBUG_LINE_NO:121
  ElseIf stringutil.Find(RaceName, "Enfant", 0) != -1 ; #DEBUG_LINE_NO:122
    IsChild = True ; #DEBUG_LINE_NO:123
  ElseIf stringutil.Find(RaceName, "Elin", 0) != -1 ; #DEBUG_LINE_NO:124
    IsChild = True ; #DEBUG_LINE_NO:125
  ElseIf stringutil.Find(RaceName, "Young", 0) != -1 ; #DEBUG_LINE_NO:126
    IsChild = True ; #DEBUG_LINE_NO:127
  ElseIf stringutil.Find(RaceName, "Monli", 0) != -1 ; #DEBUG_LINE_NO:128
    IsChild = True ; #DEBUG_LINE_NO:129
  EndIf
  Return IsChild ; #DEBUG_LINE_NO:132
EndFunction

Bool Function IsFertileRace(Race ThisRace)
  String RaceName = ThisRace.GetName() ; #DEBUG_LINE_NO:137
  Bool IsFertile = False ; #DEBUG_LINE_NO:138
  If stringutil.Find(RaceName, "Bunny", 0) != -1 ; #DEBUG_LINE_NO:140
    IsFertile = True ; #DEBUG_LINE_NO:141
  EndIf
  If stringutil.Find(RaceName, "Nymph", 0) != -1 ; #DEBUG_LINE_NO:144
    IsFertile = True ; #DEBUG_LINE_NO:145
  EndIf
  Return IsFertile ; #DEBUG_LINE_NO:148
EndFunction

Bool Function IsSmallRace(Race ThisRace)
  String RaceName = ThisRace.GetName() ; #DEBUG_LINE_NO:152
  Bool IsSmall = False ; #DEBUG_LINE_NO:153
  If stringutil.Find(RaceName, "Goblin", 0) != -1 ; #DEBUG_LINE_NO:155
    IsSmall = True ; #DEBUG_LINE_NO:156
  ElseIf stringutil.Find(RaceName, "Gnome", 0) != -1 ; #DEBUG_LINE_NO:157
    IsSmall = True ; #DEBUG_LINE_NO:158
  ElseIf stringutil.Find(RaceName, "Kobold", 0) != -1 ; #DEBUG_LINE_NO:159
    IsSmall = True ; #DEBUG_LINE_NO:160
  ElseIf stringutil.Find(RaceName, "Svirfneblin", 0) != -1 ; #DEBUG_LINE_NO:161
    IsSmall = True ; #DEBUG_LINE_NO:162
  ElseIf stringutil.Find(RaceName, "Nixie", 0) != -1 ; #DEBUG_LINE_NO:163
    IsSmall = True ; #DEBUG_LINE_NO:164
  EndIf
  Return IsSmall ; #DEBUG_LINE_NO:167
EndFunction

Int Function GetPregCount(Actor who)
  Int i = 0 ; #DEBUG_LINE_NO:172
  Int count = 0 ; #DEBUG_LINE_NO:173
  While i < 12 ; #DEBUG_LINE_NO:174
    If Victims[i].getactorref() == who ; #DEBUG_LINE_NO:175
      count += 1 ; #DEBUG_LINE_NO:176
    EndIf
    i += 1 ; #DEBUG_LINE_NO:178
  EndWhile
  Return count ; #DEBUG_LINE_NO:181
EndFunction

Function SayMessage(Actor who, String what)
  String mymessage
  Bool secondperson = False ; #DEBUG_LINE_NO:185
  Bool firstperson = False ; #DEBUG_LINE_NO:186
  If who == Game.GetPlayer() ; #DEBUG_LINE_NO:189
    secondperson = True ; #DEBUG_LINE_NO:190
    firstperson = EggFactoryFirstPerson.GetValue() as Bool ; #DEBUG_LINE_NO:191
  EndIf
  If what == "full" ; #DEBUG_LINE_NO:194
    If secondperson == True ; #DEBUG_LINE_NO:195
      If firstperson == True ; #DEBUG_LINE_NO:196
        mymessage = "I don't think I can get any more pregnant." ; #DEBUG_LINE_NO:197
      Else
        mymessage = "You cannot get any more pregnant." ; #DEBUG_LINE_NO:199
      EndIf
    Else
      mymessage = who.GetDisplayName() + ": I don't think I can get any more pregnant." ; #DEBUG_LINE_NO:202
    EndIf
  ElseIf what == "cramps" ; #DEBUG_LINE_NO:204
    If secondperson == True ; #DEBUG_LINE_NO:205
      If firstperson == True ; #DEBUG_LINE_NO:206
        mymessage = "I'm feeling mild cramps..." ; #DEBUG_LINE_NO:207
      Else
        mymessage = "You begin to feel mild cramps." ; #DEBUG_LINE_NO:209
      EndIf
    Else
      mymessage = who.GetDisplayName() + ": I feel it, soon." ; #DEBUG_LINE_NO:212
    EndIf
  ElseIf what == "labor" ; #DEBUG_LINE_NO:214
    If secondperson == True ; #DEBUG_LINE_NO:215
      If firstperson == True ; #DEBUG_LINE_NO:216
        mymessage = "Ooh! I have to push!" ; #DEBUG_LINE_NO:217
      Else
        mymessage = "You have to push!" ; #DEBUG_LINE_NO:219
      EndIf
    Else
      mymessage = who.GetDisplayName() + ": Oh! Here they come!" ; #DEBUG_LINE_NO:222
    EndIf
  ElseIf what == "water" ; #DEBUG_LINE_NO:224
    If secondperson == True ; #DEBUG_LINE_NO:225
      If firstperson == True ; #DEBUG_LINE_NO:226
        mymessage = "I think my water just broke!" ; #DEBUG_LINE_NO:227
      Else
        mymessage = "You think your water just broke." ; #DEBUG_LINE_NO:229
      EndIf
    Else
      mymessage = who.GetDisplayName() + ": My water just broke. Soon!" ; #DEBUG_LINE_NO:232
    EndIf
  ElseIf what == "finished" ; #DEBUG_LINE_NO:234
    If secondperson == True ; #DEBUG_LINE_NO:235
      If firstperson == True ; #DEBUG_LINE_NO:236
        mymessage = "I'm finally finished." ; #DEBUG_LINE_NO:237
      Else
        mymessage = "You're finally finished." ; #DEBUG_LINE_NO:239
      EndIf
    Else
      mymessage = who.GetDisplayName() + ": That's all of them, for now." ; #DEBUG_LINE_NO:242
    EndIf
  ElseIf what == "maybenot" ; #DEBUG_LINE_NO:244
    If secondperson == True ; #DEBUG_LINE_NO:245
      mymessage = "Or maybe not..." ; #DEBUG_LINE_NO:246
    Else
      mymessage = who.GetDisplayName() + ": Or maybe not..." ; #DEBUG_LINE_NO:248
    EndIf
  ElseIf what == "dispelled" ; #DEBUG_LINE_NO:250
    If secondperson == True ; #DEBUG_LINE_NO:251
      If firstperson == True ; #DEBUG_LINE_NO:252
        mymessage = "I can feel the curse fading away." ; #DEBUG_LINE_NO:253
      Else
        mymessage = "The curse has faded from you." ; #DEBUG_LINE_NO:255
      EndIf
    Else
      mymessage = who.GetDisplayName() + ": It seems the curse has worn off." ; #DEBUG_LINE_NO:258
    EndIf
  ElseIf what == "breasts" ; #DEBUG_LINE_NO:260
    If secondperson == True ; #DEBUG_LINE_NO:261
      If firstperson == True ; #DEBUG_LINE_NO:262
        mymessage = "My breasts feel so heavy." ; #DEBUG_LINE_NO:263
      Else
        mymessage = "Your breasts feel so heavy and sensitive." ; #DEBUG_LINE_NO:265
      EndIf
    Else
      mymessage = who.GetDisplayName() + ": Ow, my breasts feel so heavy." ; #DEBUG_LINE_NO:268
    EndIf
  ElseIf what == "pregstart" ; #DEBUG_LINE_NO:270
    If secondperson == True ; #DEBUG_LINE_NO:271
      If firstperson == True ; #DEBUG_LINE_NO:272
        mymessage = "I feel kind of bloated." ; #DEBUG_LINE_NO:273
      Else
        mymessage = "You feel vaguely bloated." ; #DEBUG_LINE_NO:275
      EndIf
    Else
      mymessage = who.GetDisplayName() + ": I feel a bit bloated." ; #DEBUG_LINE_NO:278
    EndIf
  EndIf
  If who.Is3dLoaded() ; #DEBUG_LINE_NO:282
    Debug.notification(mymessage) ; #DEBUG_LINE_NO:283
  EndIf
EndFunction

Int Function GetAdjustedDragonSouls(Actor who)
  If MQ104.GetStage() < 90 && who == Game.GetPlayer() ; #DEBUG_LINE_NO:289
    Return -1 ; #DEBUG_LINE_NO:290
  Else
    Return who.GetActorValue("dragonsouls") as Int ; #DEBUG_LINE_NO:292
  EndIf
EndFunction

Function AddFluidAndDebuff(Actor who)
  If who.GetItemCount(eggfactoryfluid as Form) < 1 ; #DEBUG_LINE_NO:297
    who.AddItem(eggfactoryfluid as Form, 1, True) ; #DEBUG_LINE_NO:298
  EndIf
  If !who.isequipped(eggfactoryfluid as Form) ; #DEBUG_LINE_NO:300
    who.EquipItem(eggfactoryfluid as Form, True, True) ; #DEBUG_LINE_NO:301
  EndIf
  If !who.hasspell(eggfactorylabordebuff as Form) ; #DEBUG_LINE_NO:303
    who.addspell(eggfactorylabordebuff, False) ; #DEBUG_LINE_NO:304
  EndIf
EndFunction

Function IncrementAspect(Actor who, Int pregtype)
  Faction AFaction = AspectFactions[pregtype] ; #DEBUG_LINE_NO:332
  Int rank = who.GetFactionRank(AFaction) ; #DEBUG_LINE_NO:334
  If rank == -2 ; #DEBUG_LINE_NO:335
    who.AddToFaction(AFaction) ; #DEBUG_LINE_NO:336
  ElseIf rank == 4 ; #DEBUG_LINE_NO:337
    who.addspell(AspectAbilites[pregtype], True) ; #DEBUG_LINE_NO:338
  EndIf
  who.ModFactionRank(AFaction, 1) ; #DEBUG_LINE_NO:340
EndFunction

Float Function CalcAdjustedBellyScale(Int stage, Int twins, Actor who)
  Float adjusted_belly_scale = stage as Float * 0.119999997 ; #DEBUG_LINE_NO:344
  adjusted_belly_scale *= 1.0 + (twins as Float * 0.5) ; #DEBUG_LINE_NO:346
  adjusted_belly_scale *= EggFactoryBellyMult.GetValue() ; #DEBUG_LINE_NO:347
  If Self.IsSmallRace(who.GetRace()) == True ; #DEBUG_LINE_NO:349
    adjusted_belly_scale *= 1.5 ; #DEBUG_LINE_NO:350
  EndIf
  If adjusted_belly_scale > EggFactoryMaxScale.GetValue() ; #DEBUG_LINE_NO:353
    adjusted_belly_scale = EggFactoryMaxScale.GetValue() ; #DEBUG_LINE_NO:354
  EndIf
  Return adjusted_belly_scale ; #DEBUG_LINE_NO:359
EndFunction

Int Function GetTwins(Actor who, Int chance)
  Int twins = EggFactoryMinMultiples.GetValue() as Int ; #DEBUG_LINE_NO:363
  If Self.IsFertileRace(who.GetRace()) == True ; #DEBUG_LINE_NO:365
    twins += 1 ; #DEBUG_LINE_NO:366
  EndIf
  If who.haseffectkeyword(eggfactoryenchfertile) ; #DEBUG_LINE_NO:369
    twins += 1 ; #DEBUG_LINE_NO:370
  EndIf
  chance += 5 * who.GetItemCount(eggfactorycharm as Form) ; #DEBUG_LINE_NO:373
  While (twins as Float < EggFactoryMaxMultiples.GetValue()) && (Utility.randomfloat(0.0, 100.0) < chance as Float) ; #DEBUG_LINE_NO:375
    twins += 1 ; #DEBUG_LINE_NO:376
  EndWhile
  Return twins ; #DEBUG_LINE_NO:379
EndFunction

Function InitPregnancy(Int i, Int startpoint)
  gestation_cur[i] = startpoint ; #DEBUG_LINE_NO:383
  gestation_total[i] = 50 ; #DEBUG_LINE_NO:385
  twinscount[i] = Self.GetTwins(Victims[i].getactorref(), TwinChanceVars[PregTypes[i]].GetValue() as Int) ; #DEBUG_LINE_NO:386
  lastgrowth[i] = Utility.GetCurrentGameTime() * 24.0 ; #DEBUG_LINE_NO:387
EndFunction

Function AdvanceGestation(Int i)
  Int pregtype = PregTypes[i] ; #DEBUG_LINE_NO:391
  Actor victim = Victims[i].getactorref() ; #DEBUG_LINE_NO:394
  If gestation_total[i] == 0 ; #DEBUG_LINE_NO:395
    Self.InitPregnancy(i, 0) ; #DEBUG_LINE_NO:396
  Else
    gestation_cur[i] = gestation_cur[i] + 1 ; #DEBUG_LINE_NO:398
    If victim.haseffectkeyword(eggfactoryenchhold) && gestation_cur[i] > 50 ; #DEBUG_LINE_NO:399
      gestation_total[i] = gestation_total[i] + 1 ; #DEBUG_LINE_NO:400
    EndIf
  EndIf
  If gestation_cur[i] == 40 && victim.Is3dLoaded() ; #DEBUG_LINE_NO:404
    Self.SayMessage(victim, "breasts") ; #DEBUG_LINE_NO:405
  EndIf
  If gestation_cur[i] >= 10 ; #DEBUG_LINE_NO:408
    If victim == Game.GetPlayer() ; #DEBUG_LINE_NO:409
      EggFactoryPlayerMilkState.SetValue(2 as Float) ; #DEBUG_LINE_NO:410
    EndIf
  EndIf
  If gestation_cur[i] >= 40 ; #DEBUG_LINE_NO:414
    If victim == Game.GetPlayer() ; #DEBUG_LINE_NO:415
      EggFactoryPlayerMilkState.SetValue(3 as Float) ; #DEBUG_LINE_NO:416
    EndIf
  EndIf
  If gestation_cur[i] == gestation_total[i] - 1 && victim.Is3dLoaded() ; #DEBUG_LINE_NO:420
    Self.SayMessage(victim, "cramps") ; #DEBUG_LINE_NO:421
    LaborStates[i] = 1 ; #DEBUG_LINE_NO:422
  EndIf
  If gestation_cur[i] == gestation_total[i] && victim.Is3dLoaded() ; #DEBUG_LINE_NO:425
    Self.SayMessage(victim, "water") ; #DEBUG_LINE_NO:426
    LaborStates[i] = 3 ; #DEBUG_LINE_NO:427
    Self.AddFluidAndDebuff(victim) ; #DEBUG_LINE_NO:428
  EndIf
  Float belly_Scale = Self.CalcAdjustedBellyScale(gestation_cur[i], twinscount[i], victim) ; #DEBUG_LINE_NO:431
  Self.setnodescale(victim, "NPC Belly", belly_Scale, i) ; #DEBUG_LINE_NO:432
  If gestation_cur[i] > gestation_total[i] ; #DEBUG_LINE_NO:434
    Self.SayMessage(victim, "labor") ; #DEBUG_LINE_NO:435
    LaborStates[i] = 5 ; #DEBUG_LINE_NO:436
    Int twincount = twinscount[i] ; #DEBUG_LINE_NO:437
    Int mineggs = EggCountsMin[pregtype] * (1 + twincount) ; #DEBUG_LINE_NO:438
    Int maxeggs = EggCountsMax[pregtype] * (1 + twincount) ; #DEBUG_LINE_NO:439
    EggCountsLeft[i] = Utility.randomint(mineggs, maxeggs) ; #DEBUG_LINE_NO:440
    Float maxbellyscale = Self.CalcAdjustedBellyScale(gestation_cur[i], twinscount[i], victim) ; #DEBUG_LINE_NO:441
    bellyscalemults[i] = (maxbellyscale - 1.0) / EggCountsLeft[i] as Float ; #DEBUG_LINE_NO:442
    LaborRates[i] = LaborRateVars[pregtype].GetValue() as Int ; #DEBUG_LINE_NO:444
    PushesToLay[i] = Self.CalcPushesNeeded(LaborRates[i], 1) ; #DEBUG_LINE_NO:445
    TicsToNextPush[i] = Utility.randomint(1, 4) ; #DEBUG_LINE_NO:446
    wassneaking[i] = victim.IsSneaking() ; #DEBUG_LINE_NO:447
  EndIf
EndFunction

Function RegisterEggFactoryEvents()
  Self.UnRegisterForModEvent("EggFactory_Impregnate") ; #DEBUG_LINE_NO:454
  Self.UnRegisterForModEvent("EggFactory_RapidStart") ; #DEBUG_LINE_NO:455
  Self.UnRegisterForModEvent("EggFactory_Uncurse") ; #DEBUG_LINE_NO:456
  Self.UnRegisterForModEvent("EggFactory_Info") ; #DEBUG_LINE_NO:457
  Self.UnRegisterForModEvent("EggFactory_ConfigChange") ; #DEBUG_LINE_NO:458
  Self.RegisterForModEvent("EggFactory_Impregnate", "OnImpregnate") ; #DEBUG_LINE_NO:461
  Self.RegisterForModEvent("EggFactory_RapidStart", "OnRapidStart") ; #DEBUG_LINE_NO:462
  Self.RegisterForModEvent("EggFactory_Uncurse", "OnUnCurse") ; #DEBUG_LINE_NO:463
  Self.RegisterForModEvent("EggFactory_Info", "OnInfoReq") ; #DEBUG_LINE_NO:464
  Self.RegisterForModEvent("EggFactory_ConfigChange", "OnConfigChange") ; #DEBUG_LINE_NO:465
EndFunction

Event OnInit()
  Debug.trace("eggfactory on init event running", 0) ; #DEBUG_LINE_NO:469
  Self.RegisterEggFactoryEvents() ; #DEBUG_LINE_NO:470
  Self.RegisterForSingleupdate(1 as Float) ; #DEBUG_LINE_NO:471
EndEvent

Function OnVersionChange()
  Int i = 0 ; #DEBUG_LINE_NO:475
EndFunction

Function OnConfigChange()
  Debug.trace("EggFactory options changed in MCM.", 0) ; #DEBUG_LINE_NO:479
  Int i = 0 ; #DEBUG_LINE_NO:480
  While i < 12 ; #DEBUG_LINE_NO:481
    If Victims[i].getactorref() != None ; #DEBUG_LINE_NO:482
      Self.clearnodescale(Victims[i].getactorref(), "NPC Belly", i) ; #DEBUG_LINE_NO:483
      Self.clearlegacynodescale(Victims[i].getactorref(), "NPC Belly") ; #DEBUG_LINE_NO:484
      Self.setnodescale(Victims[i].getactorref(), "NPC Belly", Self.CalcAdjustedBellyScale(gestation_cur[i], twinscount[i], Victims[i].getactorref()), i) ; #DEBUG_LINE_NO:485
    EndIf
    i += 1 ; #DEBUG_LINE_NO:487
  EndWhile
EndFunction

Function OnInfoReq(Form infoform)
  String statustext = "" ; #DEBUG_LINE_NO:492
  Actor victim = infoform as Actor ; #DEBUG_LINE_NO:493
  Bool victimfound = False ; #DEBUG_LINE_NO:494
  Float percentdone = 0.0 ; #DEBUG_LINE_NO:495
  Int i = 0 ; #DEBUG_LINE_NO:496
  While i < 12 ; #DEBUG_LINE_NO:497
    If victim == Victims[i].getactorref() ; #DEBUG_LINE_NO:498
      statustext += "Pregnant with " ; #DEBUG_LINE_NO:499
      If PregTypes[i] == 1 ; #DEBUG_LINE_NO:500
        statustext += "bird eggs." ; #DEBUG_LINE_NO:501
      ElseIf PregTypes[i] == 2 ; #DEBUG_LINE_NO:502
        statustext += "spider eggs." ; #DEBUG_LINE_NO:503
      ElseIf PregTypes[i] == 3 ; #DEBUG_LINE_NO:504
        statustext += "fish eggs." ; #DEBUG_LINE_NO:505
      ElseIf PregTypes[i] == 4 ; #DEBUG_LINE_NO:506
        statustext += "chaurus eggs." ; #DEBUG_LINE_NO:507
      ElseIf PregTypes[i] == 5 ; #DEBUG_LINE_NO:508
        statustext += "large bird eggs." ; #DEBUG_LINE_NO:509
      ElseIf PregTypes[i] == 6 ; #DEBUG_LINE_NO:510
        statustext += "dragon eggs." ; #DEBUG_LINE_NO:511
      Else
        statustext += "unknown." ; #DEBUG_LINE_NO:513
      EndIf
      statustext += "\n" ; #DEBUG_LINE_NO:515
      If twinscount[i] == 1 ; #DEBUG_LINE_NO:516
        statustext += "Twins!\n" ; #DEBUG_LINE_NO:517
      ElseIf twinscount[i] == 2 ; #DEBUG_LINE_NO:518
        statustext += "Triplets!\n" ; #DEBUG_LINE_NO:519
      ElseIf twinscount[i] == 3 ; #DEBUG_LINE_NO:520
        statustext += "Quadruplets!\n" ; #DEBUG_LINE_NO:521
      ElseIf twinscount[i] == 4 ; #DEBUG_LINE_NO:522
        statustext += "Quintuplets!\n" ; #DEBUG_LINE_NO:523
      ElseIf twinscount[i] == 5 ; #DEBUG_LINE_NO:524
        statustext += "Sextuplets!\n" ; #DEBUG_LINE_NO:525
      ElseIf twinscount[i] == 6 ; #DEBUG_LINE_NO:526
        statustext += "Septuplets!\n" ; #DEBUG_LINE_NO:527
      EndIf
      percentdone = (gestation_cur[i] as Float / gestation_total[i] as Float) * 100.0 ; #DEBUG_LINE_NO:529
      statustext += percentdone as String ; #DEBUG_LINE_NO:530
      statustext += "% along.\n" ; #DEBUG_LINE_NO:531
      If UncurseQueued[i] == True ; #DEBUG_LINE_NO:532
        statustext += "Curse will break after delivery.\n" ; #DEBUG_LINE_NO:533
      EndIf
      victimfound = True ; #DEBUG_LINE_NO:535
    EndIf
    i += 1 ; #DEBUG_LINE_NO:537
  EndWhile
  If victimfound ; #DEBUG_LINE_NO:539
    Debug.messagebox(statustext) ; #DEBUG_LINE_NO:540
  Else
    Debug.messagebox("Not pregnant.") ; #DEBUG_LINE_NO:542
  EndIf
EndFunction

Function DoUncurse(Actor victim, Int i, Bool rescalebelly)
  Int pregtype = PregTypes[i] ; #DEBUG_LINE_NO:547
  victim.removespell(eggfactorylabordebuff) ; #DEBUG_LINE_NO:548
  victim.UnequipItem(eggfactoryfluid as Form, False, True) ; #DEBUG_LINE_NO:549
  victim.RemoveItem(eggfactoryfluid as Form, 1, True, None) ; #DEBUG_LINE_NO:550
  gestation_cur[i] = 0 ; #DEBUG_LINE_NO:551
  gestation_total[i] = 0 ; #DEBUG_LINE_NO:552
  LaborStates[i] = 0 ; #DEBUG_LINE_NO:553
  doingsecondload[i] = False ; #DEBUG_LINE_NO:554
  PregTypes[i] = 0 ; #DEBUG_LINE_NO:555
  UncurseQueued[i] = False ; #DEBUG_LINE_NO:556
  If rescalebelly ; #DEBUG_LINE_NO:559
    Self.setnodescale(victim, "NPC Belly", 0.0, i) ; #DEBUG_LINE_NO:560
  EndIf
  Self.SayMessage(victim, "dispelled") ; #DEBUG_LINE_NO:562
  If victim == Game.GetPlayer() ; #DEBUG_LINE_NO:563
    EggFactoryPlayerMilkCooldown.SetValue(Utility.randomint(8, 24) as Float) ; #DEBUG_LINE_NO:564
  EndIf
  If (EggFactoryBleedout.GetValueInt() as Bool == True) && victim.GetAnimationVariableBool("IsBleedingOut") ; #DEBUG_LINE_NO:566
    Debug.SendAnimationEvent(victim as ObjectReference, "bleedOutStop") ; #DEBUG_LINE_NO:567
  EndIf
  Victims[i].TryToClear() ; #DEBUG_LINE_NO:570
EndFunction

Function OnUnCurse(Form uncursed)
  Actor victim = uncursed as Actor ; #DEBUG_LINE_NO:574
  Int i = 0 ; #DEBUG_LINE_NO:575
  Bool removedone = False ; #DEBUG_LINE_NO:576
  While i < 12 && removedone == False ; #DEBUG_LINE_NO:577
    If victim == Victims[i].getactorref() ; #DEBUG_LINE_NO:578
      If gestation_cur[i] < 10 ; #DEBUG_LINE_NO:579
        Self.DoUncurse(victim, i, True) ; #DEBUG_LINE_NO:580
      Else
        UncurseQueued[i] = True ; #DEBUG_LINE_NO:582
      EndIf
      removedone = True ; #DEBUG_LINE_NO:584
    EndIf
    i += 1 ; #DEBUG_LINE_NO:586
  EndWhile
EndFunction

Int Function DoShuffle(Int currentpregtype)
  Int newpregtype
  Int[] allowedtypes = new Int[6] ; #DEBUG_LINE_NO:591
  Int i = 1 ; #DEBUG_LINE_NO:592
  Int j = 0 ; #DEBUG_LINE_NO:593
  If ShuffleVars[currentpregtype].GetValueInt() > 0 ; #DEBUG_LINE_NO:596
    While i < 7 ; #DEBUG_LINE_NO:597
      If ShuffleVars[i].GetValueInt() > 0 ; #DEBUG_LINE_NO:598
        allowedtypes[j] = i ; #DEBUG_LINE_NO:599
        j += 1 ; #DEBUG_LINE_NO:600
      EndIf
      i += 1 ; #DEBUG_LINE_NO:602
    EndWhile
    If j == 0 ; #DEBUG_LINE_NO:605
      Debug.notification("No egg types selected to shuffle!") ; #DEBUG_LINE_NO:606
      newpregtype = currentpregtype ; #DEBUG_LINE_NO:607
    Else
      Int index = Utility.randomint(1, j) - 1 ; #DEBUG_LINE_NO:609
      newpregtype = allowedtypes[index] ; #DEBUG_LINE_NO:610
    EndIf
  Else
    newpregtype = currentpregtype ; #DEBUG_LINE_NO:613
  EndIf
  If newpregtype > 6 || newpregtype < 1 ; #DEBUG_LINE_NO:616
    Debug.notification("New egg type failed sanity check!") ; #DEBUG_LINE_NO:617
    newpregtype = currentpregtype ; #DEBUG_LINE_NO:618
  EndIf
  Return newpregtype ; #DEBUG_LINE_NO:621
EndFunction

Function LaborFinished(Int i)
  Actor victim = Victims[i].getactorref() ; #DEBUG_LINE_NO:626
  If victim ; #DEBUG_LINE_NO:627
    Int pregtype = PregTypes[i] ; #DEBUG_LINE_NO:628
    LaborStates[i] = 0 ; #DEBUG_LINE_NO:629
    victim.removespell(eggfactorylabordebuff) ; #DEBUG_LINE_NO:630
    victim.UnequipItem(eggfactoryfluid as Form, False, True) ; #DEBUG_LINE_NO:631
    victim.RemoveItem(eggfactoryfluid as Form, 1, True, None) ; #DEBUG_LINE_NO:632
    Self.SayMessage(victim, "finished") ; #DEBUG_LINE_NO:634
    Self.clearnodescale(victim, "NPC Belly", i) ; #DEBUG_LINE_NO:635
    If EggFactoryBleedout.GetValueInt() as Bool == True ; #DEBUG_LINE_NO:637
      If victim.GetAnimationVariableBool("IsBleedingOut") ; #DEBUG_LINE_NO:638
        Debug.SendAnimationEvent(victim as ObjectReference, "bleedOutStop") ; #DEBUG_LINE_NO:639
      EndIf
    ElseIf wassneaking[i] == False && victim.IsSneaking() ; #DEBUG_LINE_NO:641
      victim.startsneaking() ; #DEBUG_LINE_NO:642
    EndIf
    Self.IncrementAspect(victim, pregtype) ; #DEBUG_LINE_NO:645
    If UncurseQueued[i] == True ; #DEBUG_LINE_NO:646
      Self.DoUncurse(victim, i, True) ; #DEBUG_LINE_NO:647
    Else
      If pregtype < 6 && (EggFactoryShuffleMode.GetValue() > 0 as Float) ; #DEBUG_LINE_NO:649
        PregTypes[i] = Self.DoShuffle(pregtype) ; #DEBUG_LINE_NO:650
      EndIf
      Self.InitPregnancy(i, 1) ; #DEBUG_LINE_NO:653
      Self.AdvanceGestation(i) ; #DEBUG_LINE_NO:654
      If doingsecondload[i] == True ; #DEBUG_LINE_NO:655
        doingsecondload[i] = False ; #DEBUG_LINE_NO:656
      ElseIf Utility.randomint(1, 100) as Float < ExtraChanceVars[PregTypes[i]].GetValue() ; #DEBUG_LINE_NO:657
        Self.SayMessage(victim, "maybenot") ; #DEBUG_LINE_NO:658
        doingsecondload[i] = True ; #DEBUG_LINE_NO:659
      EndIf
    EndIf
    If victim == Game.GetPlayer() && notesent == False ; #DEBUG_LINE_NO:668
      Location playerLoc = victim.GetCurrentLocation() ; #DEBUG_LINE_NO:669
      If (playerLoc.HasKeyWord(loctypecity) || playerLoc.HasKeyWord(loctypetown) || playerLoc.HasKeyWord(loctypeinn)) && !playerLoc.HasKeyWord(LocTypePlayerHouse) ; #DEBUG_LINE_NO:670
        CourierScript.AddItemToContainer(EggFactoryCourierNote as Form, 1) ; #DEBUG_LINE_NO:671
        notesent = True ; #DEBUG_LINE_NO:672
      EndIf
    EndIf
    victim.removespell(eggfactorylabordebuff) ; #DEBUG_LINE_NO:677
    victim.UnequipItem(eggfactoryfluid as Form, False, True) ; #DEBUG_LINE_NO:678
    victim.RemoveItem(eggfactoryfluid as Form, 1, True, None) ; #DEBUG_LINE_NO:679
  EndIf
EndFunction

Function OnRapidStart(Form actorform, Int rapidness)
  Actor victim = actorform as Actor ; #DEBUG_LINE_NO:686
  Int i = 0 ; #DEBUG_LINE_NO:687
  While i < 12 ; #DEBUG_LINE_NO:688
    If victim == Victims[i].getactorref() ; #DEBUG_LINE_NO:689
      If PregTypes[i] < 6 ; #DEBUG_LINE_NO:690
        rapidpoints[i] = rapidpoints[i] + rapidness ; #DEBUG_LINE_NO:691
      Else
        rapidpoints[i] = rapidpoints[i] + 1 ; #DEBUG_LINE_NO:693
      EndIf
    EndIf
    i += 1 ; #DEBUG_LINE_NO:696
  EndWhile
EndFunction

Function OnImpregnate(Form actorform, Int pregtype, Int startpoint)
  Actor victim = actorform as Actor ; #DEBUG_LINE_NO:701
  Int i = 0 ; #DEBUG_LINE_NO:702
  Bool alreadypreg = False ; #DEBUG_LINE_NO:703
  Bool slotfound = False ; #DEBUG_LINE_NO:704
  Bool IsChild = False ; #DEBUG_LINE_NO:705
  Int currentcount = Self.GetPregCount(victim) ; #DEBUG_LINE_NO:706
  Int preglimit = EggFactorymultiLimit.GetValue() as Int ; #DEBUG_LINE_NO:707
  If currentcount >= preglimit ; #DEBUG_LINE_NO:709
    alreadypreg = True ; #DEBUG_LINE_NO:710
    Self.SayMessage(victim, "full") ; #DEBUG_LINE_NO:711
  EndIf
  If Self.IsChildRace(victim.GetRace()) == True ; #DEBUG_LINE_NO:714
    Debug.notification("Cannot impregnate a child!") ; #DEBUG_LINE_NO:715
    IsChild = True ; #DEBUG_LINE_NO:716
  EndIf
  If !alreadypreg && !IsChild ; #DEBUG_LINE_NO:719
    While i < 12 && !slotfound ; #DEBUG_LINE_NO:720
      If Victims[i].forcerefifempty(victim as ObjectReference) ; #DEBUG_LINE_NO:721
        Debug.trace(victim.GetDisplayName() + " set to pregnancy slot " + i as String, 0) ; #DEBUG_LINE_NO:722
        slotfound = True ; #DEBUG_LINE_NO:723
        PregTypes[i] = pregtype ; #DEBUG_LINE_NO:724
        DragonSoulCount[i] = Self.GetAdjustedDragonSouls(victim) ; #DEBUG_LINE_NO:725
        Self.InitPregnancy(i, startpoint) ; #DEBUG_LINE_NO:726
        Self.AdvanceGestation(i) ; #DEBUG_LINE_NO:727
        Self.SayMessage(victim, "pregstart") ; #DEBUG_LINE_NO:728
      EndIf
      i += 1 ; #DEBUG_LINE_NO:731
    EndWhile
  EndIf
EndFunction

Int Function CalcPushesNeeded(Int rate, Int initial)
  Int pushes = 0 ; #DEBUG_LINE_NO:738
  If rate == 3 ; #DEBUG_LINE_NO:739
    pushes = Utility.randomint(1, 3) ; #DEBUG_LINE_NO:740
  ElseIf rate == 4 ; #DEBUG_LINE_NO:741
    pushes = Utility.randomint(1, 4) + Utility.randomint(1, 4) ; #DEBUG_LINE_NO:742
  ElseIf rate == 5 ; #DEBUG_LINE_NO:743
    pushes = Utility.randomint(1, 6) + Utility.randomint(1, 6) + Utility.randomint(1, 6) + Utility.randomint(1, 6) ; #DEBUG_LINE_NO:744
  Else
    pushes = 1 ; #DEBUG_LINE_NO:746
  EndIf
  If initial > 0 ; #DEBUG_LINE_NO:749
    pushes += Utility.randomint(1, 4) ; #DEBUG_LINE_NO:750
  EndIf
  Return pushes - 1 ; #DEBUG_LINE_NO:753
EndFunction

Function LaborPose(Int idx)
  Actor who = Victims[idx].getactorref() ; #DEBUG_LINE_NO:757
  If who as Bool && who.Is3dLoaded() ; #DEBUG_LINE_NO:758
    If who.GetFlyingState() == 0 && !who.IsSneaking() && !who.IsSwimming() && !who.IsOnMount() && !who.IsDead() ; #DEBUG_LINE_NO:759
      who.startsneaking() ; #DEBUG_LINE_NO:760
      If EggFactoryBleedout.GetValueInt() as Bool == True ; #DEBUG_LINE_NO:764
        If who.GetPlayerControls() && who.GetSleepState() <= 2 && who.GetSitState() <= 2 && !who.GetAnimationVariableBool("IsBleedingOut") ; #DEBUG_LINE_NO:765
          Debug.SendAnimationEvent(who as ObjectReference, "bleedOutStart") ; #DEBUG_LINE_NO:766
        EndIf
      EndIf
    ElseIf EggFactoryDismount.GetValueInt() as Bool == True ; #DEBUG_LINE_NO:769
      If who.GetPlayerControls() && who.IsOnMount() ; #DEBUG_LINE_NO:770
        who.Dismount() ; #DEBUG_LINE_NO:771
      EndIf
    EndIf
  EndIf
EndFunction

Function LaborMoan(Int idx)
  Actor victim = Victims[idx].getactorref() ; #DEBUG_LINE_NO:779
  If victim as Bool && victim.Is3dLoaded() ; #DEBUG_LINE_NO:780
    Int moan
    Float maxvolume = EggFactoryVoiceVolume.GetValue() ; #DEBUG_LINE_NO:781
    If victim.GetActorBase().GetSex() == 0 ; #DEBUG_LINE_NO:784
      moan = EggFactoryLaborMale.play(victim as ObjectReference) ; #DEBUG_LINE_NO:785
    Else
      moan = EggFactoryLaborFemale.play(victim as ObjectReference) ; #DEBUG_LINE_NO:787
    EndIf
    Sound.SetInstanceVolume(moan, Utility.randomfloat(maxvolume * 0.699999988, maxvolume)) ; #DEBUG_LINE_NO:790
  EndIf
EndFunction

Function LaborPush(Int idx)
  Actor victim = Victims[idx].getactorref() ; #DEBUG_LINE_NO:795
  If victim ; #DEBUG_LINE_NO:796
    If PushesToLay[idx] > 0 ; #DEBUG_LINE_NO:797
      PushesToLay[idx] = PushesToLay[idx] - 1 ; #DEBUG_LINE_NO:798
    Else
      Self.LayEggs(idx) ; #DEBUG_LINE_NO:800
      If EggCountsLeft[idx] > 0 ; #DEBUG_LINE_NO:801
        PushesToLay[idx] = Self.CalcPushesNeeded(LaborRates[idx], 0) ; #DEBUG_LINE_NO:802
      Else
        Int handle = modevent.Create("EggFactory_LaborFinished") ; #DEBUG_LINE_NO:804
        If handle ; #DEBUG_LINE_NO:805
          modevent.pushform(handle, victim as Form) ; #DEBUG_LINE_NO:806
          modevent.send(handle) ; #DEBUG_LINE_NO:807
        EndIf
      EndIf
    EndIf
  EndIf
EndFunction

Function LayEggs(Int idx)
  Actor victim = Victims[idx].getactorref() ; #DEBUG_LINE_NO:815
  If victim ; #DEBUG_LINE_NO:816
    Int eggs
    Int rate = LaborRates[idx] ; #DEBUG_LINE_NO:820
    Int pregtype = PregTypes[idx] ; #DEBUG_LINE_NO:821
    If rate == 1 ; #DEBUG_LINE_NO:825
      eggs = Utility.randomint(1, 3) ; #DEBUG_LINE_NO:826
    ElseIf rate == 0 ; #DEBUG_LINE_NO:827
      eggs = Utility.randomint(3, 7) ; #DEBUG_LINE_NO:828
    Else
      eggs = 1 ; #DEBUG_LINE_NO:830
    EndIf
    If eggs > EggCountsLeft[idx] ; #DEBUG_LINE_NO:833
      eggs = EggCountsLeft[idx] ; #DEBUG_LINE_NO:834
    EndIf
    While eggs > 0 ; #DEBUG_LINE_NO:837
      Ingredient eggitemreal
      MiscObject eggitem
      Int birdtype = Utility.randomint(1, 3) ; #DEBUG_LINE_NO:838
      If pregtype == 1 && birdtype == 2 ; #DEBUG_LINE_NO:839
        eggitem = EggItems[7] ; #DEBUG_LINE_NO:840
        eggitemreal = EggItemsReal[7] ; #DEBUG_LINE_NO:841
      ElseIf pregtype == 1 && birdtype == 3 ; #DEBUG_LINE_NO:842
        eggitem = EggItems[8] ; #DEBUG_LINE_NO:843
        eggitemreal = EggItemsReal[8] ; #DEBUG_LINE_NO:844
      Else
        eggitem = EggItems[pregtype] ; #DEBUG_LINE_NO:846
        eggitemreal = EggItemsReal[pregtype] ; #DEBUG_LINE_NO:847
      EndIf
      If victim.Is3dLoaded() ; #DEBUG_LINE_NO:850
        ObjectReference newegg = victim.PlaceAtMe(eggitem as Form, 1, False, False) ; #DEBUG_LINE_NO:851
        newegg.MoveToNode(victim as ObjectReference, "NPC Pelvis [Pelv]") ; #DEBUG_LINE_NO:853
        newegg.SetFactionOwner(PlayerFaction) ; #DEBUG_LINE_NO:855
      Else
        victim.AddItem(eggitemreal as Form, 1, False) ; #DEBUG_LINE_NO:857
      EndIf
      eggs -= 1 ; #DEBUG_LINE_NO:860
      EggCountsLeft[idx] = EggCountsLeft[idx] - 1 ; #DEBUG_LINE_NO:861
    EndWhile
    Float newscale = 1.0 + (EggCountsLeft[idx] as Float * bellyscalemults[idx]) ; #DEBUG_LINE_NO:864
    Self.setnodescale(victim, "NPC Belly", newscale, idx) ; #DEBUG_LINE_NO:867
  EndIf
EndFunction

Function GrowthSpurt(Int i)
  Actor victim = Victims[i].getactorref() ; #DEBUG_LINE_NO:872
  Int r = Utility.randomint(5, 10) ; #DEBUG_LINE_NO:873
  Self.LaborMoan(i) ; #DEBUG_LINE_NO:874
  While r > 0 && LaborStates[i] < 5 ; #DEBUG_LINE_NO:875
    Self.AdvanceGestation(i) ; #DEBUG_LINE_NO:876
    r -= 1 ; #DEBUG_LINE_NO:877
  EndWhile
EndFunction

Event OnUpdate()
  Int i = 0 ; #DEBUG_LINE_NO:883
  If eggfactory340check != True ; #DEBUG_LINE_NO:888
    EggFactoryScaleMethod = Game.GetFormFromFile(238054, "eggfactory.esp") as GlobalVariable ; #DEBUG_LINE_NO:889
    eggfactory340check = True ; #DEBUG_LINE_NO:890
  EndIf
  If eggfactory360check != True ; #DEBUG_LINE_NO:893
    EggFactorymultiLimit = Game.GetFormFromFile(271154, "eggfactory.esp") as GlobalVariable ; #DEBUG_LINE_NO:894
    eggfactory360check = True ; #DEBUG_LINE_NO:895
    Self.OnConfigChange() ; #DEBUG_LINE_NO:896
  EndIf
  If eggfactory380check != True ; #DEBUG_LINE_NO:899
    Debug.notification("Egg Factory Upgrading to 3.8.0") ; #DEBUG_LINE_NO:900
    EggFactoryShutdown = Game.GetFormFromFile(57248, "eggfactory.esp") as GlobalVariable ; #DEBUG_LINE_NO:901
    GlobalVariable[] NewShuffleVars = new GlobalVariable[7] ; #DEBUG_LINE_NO:902
    NewShuffleVars[1] = Game.GetFormFromFile(287788, "eggfactory.esp") as GlobalVariable ; #DEBUG_LINE_NO:903
    NewShuffleVars[2] = Game.GetFormFromFile(287793, "eggfactory.esp") as GlobalVariable ; #DEBUG_LINE_NO:904
    NewShuffleVars[3] = Game.GetFormFromFile(287790, "eggfactory.esp") as GlobalVariable ; #DEBUG_LINE_NO:905
    NewShuffleVars[4] = Game.GetFormFromFile(287789, "eggfactory.esp") as GlobalVariable ; #DEBUG_LINE_NO:906
    NewShuffleVars[5] = Game.GetFormFromFile(287792, "eggfactory.esp") as GlobalVariable ; #DEBUG_LINE_NO:907
    NewShuffleVars[6] = Game.GetFormFromFile(287791, "eggfactory.esp") as GlobalVariable ; #DEBUG_LINE_NO:908
    ShuffleVars = NewShuffleVars ; #DEBUG_LINE_NO:909
    eggfactory380check = True ; #DEBUG_LINE_NO:910
  EndIf
  While i < 12 && eventick ; #DEBUG_LINE_NO:915
    Int pregtype = PregTypes[i] ; #DEBUG_LINE_NO:916
    Actor victim = Victims[i].getactorref() ; #DEBUG_LINE_NO:917
    If pregtype > 0 && victim as Bool ; #DEBUG_LINE_NO:918
      If EggFactoryShutdown.GetValueInt() > 0 ; #DEBUG_LINE_NO:919
        String mes = "Removing effects from " + victim.GetDisplayName() ; #DEBUG_LINE_NO:921
        Debug.notification(mes) ; #DEBUG_LINE_NO:922
        Self.DoUncurse(victim, i, True) ; #DEBUG_LINE_NO:923
      ElseIf victim.IsDead() ; #DEBUG_LINE_NO:924
        Self.DoUncurse(victim, i, False) ; #DEBUG_LINE_NO:926
      ElseIf LaborStates[i] < 5 ; #DEBUG_LINE_NO:927
        Float interval
        Float hours_passed = Utility.GetCurrentGameTime() * 24.0 - lastgrowth[i] ; #DEBUG_LINE_NO:928
        Float divisor = PregSpeedVars[pregtype].GetValue() ; #DEBUG_LINE_NO:929
        If divisor > 0 as Float ; #DEBUG_LINE_NO:930
          interval = 1.0 / divisor ; #DEBUG_LINE_NO:931
        Else
          interval = 0.0 ; #DEBUG_LINE_NO:933
        EndIf
        If gestation_cur[i] == gestation_total[i] && (interval > 0.5 || interval == 0.0) ; #DEBUG_LINE_NO:937
          interval = 0.5 ; #DEBUG_LINE_NO:938
        EndIf
        While interval > 0.0001 && hours_passed >= interval ; #DEBUG_LINE_NO:942
          Self.AdvanceGestation(i) ; #DEBUG_LINE_NO:943
          hours_passed -= interval ; #DEBUG_LINE_NO:944
          lastgrowth[i] = Utility.GetCurrentGameTime() * 24.0 ; #DEBUG_LINE_NO:945
        EndWhile
        If gestation_cur[i] < (SkipEarlyVars[PregTypes[i]].GetValue() as Int / 2) ; #DEBUG_LINE_NO:949
          Self.GrowthSpurt(i) ; #DEBUG_LINE_NO:950
        EndIf
        If rapidpoints[i] > 0 || doingsecondload[i] == True ; #DEBUG_LINE_NO:954
          Self.GrowthSpurt(i) ; #DEBUG_LINE_NO:955
          If doingsecondload[i] == False ; #DEBUG_LINE_NO:956
            rapidpoints[i] = rapidpoints[i] - 1 ; #DEBUG_LINE_NO:957
          EndIf
        EndIf
        If pregtype == 6 && Self.GetAdjustedDragonSouls(victim) > DragonSoulCount[i] ; #DEBUG_LINE_NO:962
          rapidpoints[i] = rapidpoints[i] + Utility.randomint(3, 5) * (Self.GetAdjustedDragonSouls(victim) - DragonSoulCount[i]) ; #DEBUG_LINE_NO:963
        EndIf
        DragonSoulCount[i] = Self.GetAdjustedDragonSouls(victim) ; #DEBUG_LINE_NO:965
        If victim.IsSwimming() && (gestation_cur[i] as Float < (WaterGrowthVars[pregtype].GetValue() / 2 as Float)) ; #DEBUG_LINE_NO:968
          Self.AdvanceGestation(i) ; #DEBUG_LINE_NO:969
        EndIf
      EndIf
      If victim != Game.GetPlayer() ; #DEBUG_LINE_NO:973
        If victim.GetItemCount(foodeggpotion as Form) > 0 ; #DEBUG_LINE_NO:975
          If PregTypes[i] < 6 ; #DEBUG_LINE_NO:976
            rapidpoints[i] = rapidpoints[i] + Utility.randomint(3, 5) ; #DEBUG_LINE_NO:977
          Else
            rapidpoints[i] = rapidpoints[i] + 1 ; #DEBUG_LINE_NO:979
          EndIf
          victim.RemoveItem(foodeggpotion as Form, 1, True, None) ; #DEBUG_LINE_NO:981
        EndIf
        If victim.GetItemCount(eggfactoryuncurse as Form) > 0 && UncurseQueued[i] == False ; #DEBUG_LINE_NO:985
          victim.RemoveItem(eggfactoryuncurse as Form, 1, True, None) ; #DEBUG_LINE_NO:986
          If gestation_cur[i] < 10 ; #DEBUG_LINE_NO:987
            Self.DoUncurse(victim, i, True) ; #DEBUG_LINE_NO:988
          Else
            UncurseQueued[i] = True ; #DEBUG_LINE_NO:990
          EndIf
        EndIf
      EndIf
    EndIf
    i += 1 ; #DEBUG_LINE_NO:995
  EndWhile
  eventick = !eventick ; #DEBUG_LINE_NO:998
  i = 0 ; #DEBUG_LINE_NO:1000
  While i < 12 ; #DEBUG_LINE_NO:1001
    If LaborStates[i] >= 5 ; #DEBUG_LINE_NO:1002

      bool encounterAllowed = true ; by default it's allowed
      if Game.GetModbyName("FluentEncounters.esp") != 255 ; FLEN exists
        encounterAllowed = (Quest.GetQuest("Flen_Core") as Flen_Core).Claim("Egg Push [" + i + "]")
      endif
      if encounterAllowed ; FLEN

        If TicsToNextPush[i] > 0 ; #DEBUG_LINE_NO:1003
          TicsToNextPush[i] = TicsToNextPush[i] - 1 ; #DEBUG_LINE_NO:1004
          If TicsToNextPush[i] == 0 ; #DEBUG_LINE_NO:1005
            Utility.wait(Utility.randomfloat(0.0, 0.25)) ; #DEBUG_LINE_NO:1006
            Self.LaborPose(i) ; #DEBUG_LINE_NO:1007
            Self.LaborMoan(i) ; #DEBUG_LINE_NO:1008
            Self.LaborPush(i) ; #DEBUG_LINE_NO:1009
            TicsToNextPush[i] = Utility.randomint(1, 5) ; #DEBUG_LINE_NO:1010
          EndIf
        EndIf
        If EggCountsLeft[i] <= 0 ; #DEBUG_LINE_NO:1013
          Self.LaborFinished(i) ; #DEBUG_LINE_NO:1014

          if Game.GetModbyName("FluentEncounters.esp") != 255 ; FLEN exists
            (Quest.GetQuest("Flen_Core") as Flen_Core).Release("Egg Push [" + i + "]")
          endif
        EndIf

      endif ; FLEN

    EndIf
    i += 1 ; #DEBUG_LINE_NO:1017
  EndWhile
  Self.RegisterForSingleupdate(0.5) ; #DEBUG_LINE_NO:1020
EndEvent

Function SetNodeScaleNIO(Actor akActor, String nodeName, Float value, Int idx)
  Bool isFemale = True ; #DEBUG_LINE_NO:1024
  If akActor.GetLeveledActorBase().GetSex() == 0 ; #DEBUG_LINE_NO:1025
    isFemale = False ; #DEBUG_LINE_NO:1026
  ElseIf akActor.GetLeveledActorBase().GetSex() == 1 ; #DEBUG_LINE_NO:1027
    isFemale = True ; #DEBUG_LINE_NO:1028
  Else
    Return  ; #DEBUG_LINE_NO:1030
  EndIf
  String E_Key = "EGG_MODKEY" + idx as String ; #DEBUG_LINE_NO:1032
  If value > 1.0 ; #DEBUG_LINE_NO:1035
    nioverride.AddNodeTransformScale(akActor as ObjectReference, False, isFemale, nodeName, E_Key, value) ; #DEBUG_LINE_NO:1036
    nioverride.AddNodeTransformScale(akActor as ObjectReference, True, isFemale, nodeName, E_Key, value) ; #DEBUG_LINE_NO:1037
  Else
    nioverride.RemoveNodeTransformScale(akActor as ObjectReference, False, isFemale, nodeName, E_Key) ; #DEBUG_LINE_NO:1039
    nioverride.RemoveNodeTransformScale(akActor as ObjectReference, True, isFemale, nodeName, E_Key) ; #DEBUG_LINE_NO:1040
  EndIf
  nioverride.UpdateNodeTransform(akActor as ObjectReference, False, isFemale, nodeName) ; #DEBUG_LINE_NO:1042
  nioverride.UpdateNodeTransform(akActor as ObjectReference, True, isFemale, nodeName) ; #DEBUG_LINE_NO:1043
EndFunction

Function SetNodeScaleSLIF(Actor akActor, String nodeName, Float value, Int idx)
  String sKey = "slif_belly" ; #DEBUG_LINE_NO:1047
  String eKey = "Egg Factory " + idx as String ; #DEBUG_LINE_NO:1048
  If value > 0.0 ; #DEBUG_LINE_NO:1050
    Int SLIF_event = modevent.Create("SLIF_inflate") ; #DEBUG_LINE_NO:1051
    If SLIF_event ; #DEBUG_LINE_NO:1052
      modevent.pushform(SLIF_event, akActor as Form) ; #DEBUG_LINE_NO:1053
      modevent.PushString(SLIF_event, eKey) ; #DEBUG_LINE_NO:1054
      modevent.PushString(SLIF_event, sKey) ; #DEBUG_LINE_NO:1055
      modevent.PushFloat(SLIF_event, value) ; #DEBUG_LINE_NO:1056
      modevent.PushString(SLIF_event, "EGG_MODKEY") ; #DEBUG_LINE_NO:1057
      modevent.send(SLIF_event) ; #DEBUG_LINE_NO:1058
    EndIf
  Else
    Int slif_event = modevent.Create("SLIF_unregisterNode") ; #DEBUG_LINE_NO:1061
    If slif_event ; #DEBUG_LINE_NO:1062
      modevent.pushform(slif_event, akActor as Form) ; #DEBUG_LINE_NO:1063
      modevent.PushString(slif_event, eKey) ; #DEBUG_LINE_NO:1064
      modevent.PushString(slif_event, sKey) ; #DEBUG_LINE_NO:1065
      modevent.send(slif_event) ; #DEBUG_LINE_NO:1066
    EndIf
  EndIf
EndFunction

Function setnodescale(Actor akActor, String nodeName, Float value, Int idx)
  Int scalemethod = EggFactoryScaleMethod.GetValue() as Int ; #DEBUG_LINE_NO:1072
  If scalemethod == 1 ; #DEBUG_LINE_NO:1074
    Self.SetNodeScaleNIO(akActor, nodeName, value, idx) ; #DEBUG_LINE_NO:1075
  ElseIf scalemethod == 2 ; #DEBUG_LINE_NO:1076
    Float newscale = (value - 1.0) / 5.0 ; #DEBUG_LINE_NO:1077
    String eKey = "Egg Factory " + idx as String ; #DEBUG_LINE_NO:1078
    If newscale > 0 as Float ; #DEBUG_LINE_NO:1079
      nioverride.SetBodyMorph(akActor as ObjectReference, "PregnancyBelly", eKey, newscale) ; #DEBUG_LINE_NO:1080
    Else
      nioverride.ClearBodyMorph(akActor as ObjectReference, "PregnancyBelly", eKey) ; #DEBUG_LINE_NO:1082
    EndIf
    nioverride.UpdateModelWeight(akActor as ObjectReference) ; #DEBUG_LINE_NO:1084
  ElseIf scalemethod == 3 ; #DEBUG_LINE_NO:1085
    Self.SetNodeScaleSLIF(akActor, nodeName, value, idx) ; #DEBUG_LINE_NO:1086
  EndIf
EndFunction

Function clearnodescale(Actor akActor, String nodeName, Int idx)
  String eKey = "Egg Factory " + idx as String ; #DEBUG_LINE_NO:1092
  Self.SetNodeScaleNIO(akActor, nodeName, 0.0, idx) ; #DEBUG_LINE_NO:1093
  Self.SetNodeScaleSLIF(akActor, nodeName, 0.0, idx) ; #DEBUG_LINE_NO:1094
  nioverride.ClearBodyMorph(akActor as ObjectReference, "PregnancyBelly", eKey) ; #DEBUG_LINE_NO:1095
  nioverride.UpdateModelWeight(akActor as ObjectReference) ; #DEBUG_LINE_NO:1096
EndFunction

Function clearlegacynodescale(Actor akActor, String nodeName)
  Bool isFemale = True ; #DEBUG_LINE_NO:1100
  If akActor.GetLeveledActorBase().GetSex() == 0 ; #DEBUG_LINE_NO:1101
    isFemale = False ; #DEBUG_LINE_NO:1102
  ElseIf akActor.GetLeveledActorBase().GetSex() == 1 ; #DEBUG_LINE_NO:1103
    isFemale = True ; #DEBUG_LINE_NO:1104
  Else
    Return  ; #DEBUG_LINE_NO:1106
  EndIf
  String eKey = "Egg Factory" ; #DEBUG_LINE_NO:1108
  nioverride.RemoveNodeTransformScale(akActor as ObjectReference, False, isFemale, nodeName, eKey) ; #DEBUG_LINE_NO:1109
  nioverride.RemoveNodeTransformScale(akActor as ObjectReference, True, isFemale, nodeName, eKey) ; #DEBUG_LINE_NO:1110
  Int SLIF_event = modevent.Create("SLIF_unregisterNode") ; #DEBUG_LINE_NO:1111
  If SLIF_event ; #DEBUG_LINE_NO:1112
    modevent.pushform(SLIF_event, akActor as Form) ; #DEBUG_LINE_NO:1113
    modevent.PushString(SLIF_event, eKey) ; #DEBUG_LINE_NO:1114
    modevent.PushString(SLIF_event, "slif_belly") ; #DEBUG_LINE_NO:1115
    modevent.send(SLIF_event) ; #DEBUG_LINE_NO:1116
  EndIf
  nioverride.ClearBodyMorph(akActor as ObjectReference, "PregnancyBelly", eKey) ; #DEBUG_LINE_NO:1118
  nioverride.UpdateModelWeight(akActor as ObjectReference) ; #DEBUG_LINE_NO:1119
EndFunction
